#include <vector>

#include "qblib.hh"

template<typename T>
class BAS_MAGICARRAY_ImplSTATIC;

template<typename T,unsigned Ndims>
class BAS_DYNARRAY: public BAS_MAGICARRAY_ImplSTATIC<T>
{
public:
    BAS_DYNARRAY(empty_struct, ...);
    
    T& Index(unsigned numdims, ...);
    T& DoIndex(unsigned numdims, va_list ap);
    
    void Redim(unsigned numdims, ...);
    void DoRedim(unsigned numdims, va_list ap);
    
    void Erase();
    
    using BAS_MAGICARRAY_ImplSTATIC<T>::Lbound;
    using BAS_MAGICARRAY_ImplSTATIC<T>::Ubound;

private:
    void RedimUpdate();
private:
    std::vector<T> container;
};

#include "dynarray.tcc"
